﻿Imports System.Data
Imports Npgsql

Public Class form1

    Shared serverName As String = "127.0.0.1"
    Shared port As String = "5432"
    Shared userName As String = "postgres"
    Shared password As String = "sua_senha"
    Shared databaseName As String = "Northwind_pgsql"
    Private pgsqlConnection As NpgsqlConnection = Nothing
    Private connString As String = Nothing

    Private Sub btnExecutar_Click(sender As Object, e As EventArgs) Handles btnExecutar.Click

        Dim ConexaoPG As String = String.Format("Server={0};Port={1};User Id={2};Password={3};Database={4};", serverName, port, userName, password, databaseName)
        Dim conn As NpgsqlConnection = Nothing
        Try
            'Instancia NpgsqlConnection na variavel conn
            conn = New NpgsqlConnection(ConexaoPG)
            'Abre a conexão
            conn.Open()
            'Declara e atribui a instrucao SQL de consulta
            Dim SQL As String = "SELECT * FROM public." & cboTabelas.Text
            'Instancia o NpgsqlDataAdapter responsavel pela comunicação
            'é feita a leitura dos dados preenchendo o dataset
            Dim da As Npgsql.NpgsqlDataAdapter = New NpgsqlDataAdapter(SQL, conn)
            'Instacia um DataSet
            Dim ds As DataSet = New DataSet()
            'Preenche o DataAdapter
            da.Fill(ds, cboTabelas.Text)
            'Atribui um Datasource a Grid
            dgvDados.DataSource = ds.Tables(0).DefaultView
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            If Not conn Is Nothing Then
                If conn.State = ConnectionState.Open Then
                    conn.Close()
                End If
            End If
        End Try
    End Sub

    Private Sub form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cboTabelas.SelectedIndex = 0
    End Sub
End Class



